#!/usr/bin/python3

from __future__ import absolute_import, print_function, unicode_literals

import sys, os, re

def loadfile(filename):
    in_file = open(filename, "r")
    text = in_file.read()
    in_file.close()
    return text

def edid_bytes(edid,byte1,byte2=None):
    if byte2:
        return edid[byte1*2:(byte2+1)*2]
    else:
        return edid[byte1*2:(byte1+1)*2]

edidfile = sys.argv[1]
regex = re.compile("\(II\) .*\(\d+\):\s+(.*)$")

edid = ""
lines = loadfile(edidfile)
for line in lines.split("\n"):
    m = regex.search(line)
    if m:
        line = m.group(1)
    edid += line

print("%20s %s" %("Header:", edid_bytes(edid,0,7)))
print("%20s %s" %("Manufacturer:", edid_bytes(edid,8,9)))
print("%20s %s" %("Product ID code:", edid_bytes(edid,10,11)))
print("%20s %s" %("Serial Number:", edid_bytes(edid,12,15)))
print("%20s %s" %("Week of Manufacture:", edid_bytes(edid,16)))
print("%20s %s" %("Year of Manufactur:", edid_bytes(edid,17)))
print("%20s %s" %("EDID Version:", edid_bytes(edid,18)))
print("%20s %s" %("EDID Revision:", edid_bytes(edid,19)))

print("%20s %s" %("Video input def:", edid_bytes(edid,20)))
print("%20s %s" %("Max Horiz Image(cm):", edid_bytes(edid,21)))
print("%20s %s" %("Max Vert Image(cm):", edid_bytes(edid,22)))
print("%20s %s" %("Gamma:", edid_bytes(edid,23)))
print("%20s %s" %("Power management:", edid_bytes(edid,24)))

print("%20s %s" %("Chromaticity:", edid_bytes(edid,25,34)))
print("%20s %s" %("Timing I:", edid_bytes(edid,35)))
print("%20s %s" %("Timing II:", edid_bytes(edid,36)))
print("%20s %s" %("Reserved Timing:", edid_bytes(edid,37)))
print("%20s %s" %("Standard Timing:", edid_bytes(edid,38,53)))
print("Descriptor Block 1")
print("%20s %s" %("Horiz Active (px):", edid_bytes(edid,56)))
print("%20s %s" %("Horiz Blanking:", edid_bytes(edid,57)))
print("%20s %s" %("Horiz high:", edid_bytes(edid,58)))
print("%20s %s" %("Vert Active:", edid_bytes(edid,59)))
print("%20s %s" %("Vert Blank:", edid_bytes(edid,60)))
print("%20s %s" %("Vert high:", edid_bytes(edid,61)))
print("%20s %s" %("Horz Sync Offset (px):", edid_bytes(edid,62)))
print("%20s %s" %("Horiz Sync Pulse Width (px):", edid_bytes(edid,63)))
print("%20s %s" %("Vert Sync (lines):", edid_bytes(edid,64)))
print("%20s %s" %("high:", edid_bytes(edid,65)))
print("%20s %s" %("Horiz Image Size (mm):", edid_bytes(edid,66)))
print("%20s %s" %("Vert Image Size (mm):", edid_bytes(edid,67)))
print("%20s %s" %("Image Size high:", edid_bytes(edid,68)))
print("%20s %s" %("Horiz Border:", edid_bytes(edid,69)))
print("%20s %s" %("Vert Border:", edid_bytes(edid,70)))
print("%20s %s" %("Interlacing:", edid_bytes(edid,71)))
print("Descriptor Block 2")
print("%20s %s" %("Descriptor Block 2:", edid_bytes(edid,72,89)))
print("Descriptor Block 3")
print("%20s %s" %("Descriptor Block 3:", edid_bytes(edid,90,107)))
print("Descriptor Block 4")
print("%20s %s" %("Descriptor Block 4:", edid_bytes(edid,108,125)))
print("%20s %s" %("Extension Flag:", edid_bytes(edid,126)))
print("%20s %s" %("Checksum:", edid_bytes(edid,127)))



